# <Center>IEC 62443-4-2 App & HW Guidelines </Center>

# Table of contents
1. [Objective](#Objective)
2. [Acronyms](#acronyms)
3. [Assumptions](#Assumptions)
4. [Scope](#Scope)
5. [IEC-62443-4-2 CIP Guidelines](#iec_guidelines)

   5.1 [FR-1 Identification and authentication control](#FR1)
   
   5.2 [FR-2 Use Control](#FR2)
   
   5.3 [FR-3 System Integrity](#FR3)
   
   5.4 [FR-4 Data Confidentiality](#FR4)
   
   5.5 [FR-5 Restricted Data Flow](#FR5)
   
   5.6 [FR-6 Timely Response to Events ](#FR6)
   
   5.7 [FR-7 Resource Availability ](#FR7)
   
6. [CIP Security packages](#cip_security_packages)
7. [IEC Security Layer](#iec_security_layer)

	7.1 [Running security tests](#running_security_tests)
		
	7.2 [Adding security package](#adding_new_package)
		
	7.3 [Adding security test](#adding_security_test)
		
8. [References](#References)


   ***** 
<div style='page-break-after: always'></div>

## Revision History
| Revision No | Date       | Change description                               | Author       | Reviewed by                               |
|-------------|------------|--------------------------------------------------|--------------|-------------------------------------------|
| 001         | 2021-09-30 | Draft IEC 62443-4-2 APP & HW guidelines document | Dinesh Kumar | To be reviewed by CIP Security WG members |
| 002         | 2022-01-28 | Updated all sections                             | Dinesh Kumar | To be reviewed by CIP Security WG members |





****
<div style='page-break-after: always'></div>

















<div style='page-break-after: always'></div>

***

## 1. Objective <a name="Objective"></a>

The primary objective of this document is to provide guidelines to CIP users 
for meeting IEC-62443-4-2 security requirements. The document explains about each IEC-62443-4-2 requirements whether it has already been met by CIP.

This document has been prepared based on the extensive consultation with exida, Certification Body (*CB) as part of CIP IEC-62443-4-2 Gap Assessment.

In addition this document also explains about iec security layer added in CIP to meet IEC-62443-4-2 security requirements.

## 2. Acronyms <a name="acronyms"></a>

| Acronym   | Meaning                                      |
|-----------|----------------------------------------------|
| CB        | Certification Body such as exida             |
| CIP       | Civil Infrastructure Platform                |
| CIP Users | CIP based product owner                      |
| FR        | Foundational requirements from IEC-62443-4-2 |


## 3. Assumptions <a name="Assumptions"></a>

| Assumption                               | Impact                                   |
|------------------------------------------|------------------------------------------|
| This document would be used as guideline document to meet final IEC-62443-4-2 security requirements by CIP users | Following this document as it is may impact end product security strength |

## 4. Scope <a name="Scope"></a>

This document covers IEC-62443-4-2 guidelines from IEC-62443-4-2 Gap Assessment with exida. As some of the IEC-62443-4-2 requirements are met by CIP and others are not met by CIP. IEC-62443-4-2 security requirements which are not met by CIP should be met by CIP end products.

## 5. IEC-62443-4-2 CIP Guidelines <a name="iec_guidelines"></a>

This section provides information about each IEC-62443-4-2 requirements whether it's met by CIP, or is not met by CIP. Some requirements need additional hardware support which should be met by CIP end products.

Columns provide following information in the tables of each section.

**Req ID**

This requirement id is same as in IEC-62443-4-2.

**Requirement name**

Brief name of IEC requirements

**Requirement description**

Simplified description of IEC-62443-4-2 requirements.

**Supported by CIP**

**TRUE:** Indicates 

Requirement is fully supported by CIP and CIP users don't need to do anything for meeting the requirement, just utilize the capability provided by CIP.
      
**FALSE:** Indicates 
* CIP does not support the requirement or it's partially supported by CIP 
* It requires HW solution

**Need application support**

TRUE: Indicates CIP does not alone meet this requirement and some additional  
      support from CIP user application is needed.
      
FALSE: Indicates no application support is needed.

**Need HW solution**

TRUE: Indicates the requirement needs hardware support

FALSE: Indicates no hardware support needed to meet the requirement

**CIP Recommendation**

CIP members did extensive investigation of IEC-62443-4-2 standard and had discussion with Certification Body. The recommendations are based on the discussion with Certification Body.

### Default Action <a name="Dafault_Action"></a>

Here default action means use CIP provided package or equivalent to meet the requirement.

### 5.1 FR-1 Identification and authentication control <a name="FR1"></a>

| Req ID         | Requirement name                                                                                 | Supported by CIP | Need HW solution | Need application support | Status if supported by CIP                    | CIP recommendation                                                                                                                                                                                                             |
|----------------|--------------------------------------------------------------------------------------------------|------------------|------------------|--------------------------|-----------------------------------------------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| CR-1.1         | Human user identification and authentication                                                     | TRUE             | FALSE            | FALSE                    | Completed<br>Added packages passwd, login     | The CIP platform complies with this requirement. Users can login through various interfaces (e.g. serial console, http etc).<br><br>                                                                                           |
| CR-1.1 RE(1)   | Unique identification and authentication                                                         | TRUE             | FALSE            | FALSE                    | Completed<br>Added package libpam-cracklib<br> | Same as CR-1.1                                                                                                                                                                                                                 |
| CR-1.1 RE(2)   | Multi-factor authentication for all interfaces                                                   | TRUE             | FALSE            | FALSE                    | in-progress<br>Adding package libpam-google-authenticator | The CIP platform complies with this requirement by adding google MFA Debian package. However, CIP users can use their own way to achieve this MFA.                                                                             |
| CR-1.2         | Software process and device identification and authentication                                    | FALSE            | FALSE            | TRUE                     | N.A.                                          | The CIP platform can't meet this requirement, CIP users should use their applications to meet this requirement                                                                                                                 |
| CR1.2-RE(1)    | Unique identification and authentication                                                         | FALSE            | TRUE             | FALSE                    | N.A.                                          | Same as CR-1.2                                                                                                                                                                                                                 |
| CR-1.3         | Account management                                                                               | TRUE             | FALSE            | FALSE                    | Completed<br>Added usermod package<br>        | [Default Action](#Dafault_Action)                                                                                                                                                                                              |
| CR-1.4         | Identifier management                                                                            | TRUE             | FALSE            | FALSE                    | Completed<br>Added package adduser            | [Default Action](#Dafault_Action)                                                                                                                                                                                              |
| CR-1.5         | Authenticator management - initialize authenticator content                                      | TRUE             | FALSE            | FALSE                    | Completed<br>Added package tpm2-tools, tpm2-abrmd | [Default Action](#Dafault_Action)                                                                                                                                                                                              |
| CR-1.5-RE(1)   | The authenticators on which the company rely shall be protected via hardware mechanism           | TRUE             | FALSE            | TRUE                     | Completed                                     | This requirement expects a secure storage, CIP added TPM tools. However, secure storage and any other tools needed should be met by CIP users based on their requirements.                                                     |
| NDR-1.6        | Wireless access management                                                                       | TRUE             | TRUE             | FALSE                    | In-progress<br>Wireless drivers to be included in CIP kernel | [Default Action](#Dafault_Action)                                                                                                                                                                                              |
| NDR-1.6 RE(1)  | Unique identification and authentication                                                         | TRUE             | TRUE             | FALSE                    | In-progress<br>Wireless drivers to be included in CIP kernel | [Default Action](#Dafault_Action)                                                                                                                                                                                              |
| CR-1.7         | Strength of password-based authentication                                                        | TRUE             | FALSE            | FALSE                    | Completed<br>libpam-cracklib                  | [Default Action](#Dafault_Action)                                                                                                                                                                                              |
| CR-1.7 RE(1)   | Password generation and lifetime restrictions for human users                                    | TRUE             | FALSE            | FALSE                    | Completed<br>Added packages passwd, login<br> | [Default Action](#Dafault_Action)                                                                                                                                                                                              |
| CR-1.7 RE(2)   | Password lifetime restrictions for all users (human, software process, or device)                | FALSE            | FALSE            | FALSE                    | N.A.                                          | This is for SL-4                                                                                                                                                                                                               |
| CR-1.8         | Public key infrastructure (PKI) certificates                                                     | TRUE             | FALSE            | FALSE                    | Completed<br>Added package openssl            | [Default Action](#Dafault_Action)                                                                                                                                                                                              |
| CR-1.9         | Strength of public key-based authentication - check validity of signature of a given certificate | TRUE             | FALSE            | FALSE                    | Completed<br>Added package openssl            | [Default Action](#Dafault_Action)                                                                                                                                                                                              |
| CR-1.9 RE(1)   | Hardware security for public key-based authentication                                            | TRUE             | FALSE            | TRUE                     | Completed                                     | It requires HW support, should be met by CIP users                                                                                                                                                                             |
| CR-1.10        | Authenticator feedback                                                                           | TRUE             | TRUE             | FALSE                    | Completed<br>Added package openssl            | [Default Action](#Dafault_Action)                                                                                                                                                                                              |
| CR-1.11        | Unsuccessful login attempts - limit number                                                       | TRUE             | FALSE            | FALSE                    | In-progress<br>Adding package pam-shield      | [Default Action](#Dafault_Action)                                                                                                                                                                                              |
| CR-1.12        | System use notification                                                                          | FALSE            | TRUE             | FALSE                    | N.A.                                          | CIP does not support this requirement, CIP users should implement notifications based on their requirements                                                                                                                    |
| NDR-1.13       | Access via untrusted networks                                                                    | FALSE            | TRUE             | FALSE                    | N.A.                                          | CIP does not support this requirement.<br><br>Access of networks should be monitored using network security software and tools, only used ports should be open and unused ports should be blocked to avoid unauthorized access. |
| NDR-1.13 RE(1) | Explicit access request approval                                                                 | FALSE            | TRUE             | FALSE                    | N.A.                                          | CIP does not support this requirement.<br><br>Application based security policies, explicit request should be raised to access blocked URLs or ports to monitor them closely. Requests need to be approved by an assigned role. This can be done by a human or machine user. |
| CR-1.14        | Strength of symmetric key-based authentication                                                   | TRUE             | FALSE            | FALSE                    | Completed<br>Added openssl package            | [Default Action](#Dafault_Action)                                                                                                                                                                                              |
| CR-1.14 RE(1)  | Hardware security for symmetric key-based authentication                                         | TRUE             | FALSE            | TRUE                     | N.A.                                          | Requires HW support                                                                                                                                                                                                            |

### 5.2 FR-2 Use Control <a name="FR2"></a>

| Req ID         | Requirement name                                                                 | Supported by CIP | Need HW solution | Need application support | Status if supported by CIP       | CIP recommendation                                                                                                                                                                                                                                                                                                                                             |
|----------------|----------------------------------------------------------------------------------|------------------|------------------|--------------------------|----------------------------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| CR-2.1         | Authorization enforcement                                                        | TRUE             | TRUE             | FALSE                    | Completed<br>Added acl package   | [Default Action](#Dafault_Action)<br><br>For local interface,  file and directory access control must be configured using ACL, chmod or a similar effective mechanism.<br>For network interface, user should create user groups for each protocols, e.g. apache(web server), and configure file and directory access control using ACL or a similar effective mechanism for each users in these groups. Access permissions and ACL shall be reviewed periodically. |
| CR-2.1 RE(1)   | Authorization enforcement for all users (humans, software processes and devices) | TRUE             | TRUE             | FALSE                    | Completed<br>Added acl package   | [Default Action](#Dafault_Action)                                                                                                                                                                                                                                                                                                                              |
| CR-2.1 RE(2)   | Permission mapping to roles                                                      | TRUE             | TRUE             | FALSE                    | Completed<br>Added acl package   | [Default Action](#Dafault_Action)                                                                                                                                                                                                                                                                                                                              |
| CR-2.1 RE(3)   | Supervisor override                                                              | TRUE             | TRUE             | FALSE                    | Completed<br>Added acl package   | [Default Action](#Dafault_Action)<br><br>Since the privileges/supervisor overrides are application specific, this requirement must be implemented at application level                                                                                                                                                                                         |
| CR-2.1 RE(4)   | Dual approval                                                                    | FALSE            | FALSE            | FALSE                    | N.A.                             | This is for SL-4                                                                                                                                                                                                                                                                                                                                               |
| CR-2.2         | Wireless use control                                                             | FALSE            | TRUE             | FALSE                    | N.A.                             | This requirement can not be supported by CIP. However, CIP has following recommendations for meeting this requirement<br><br>**SYSTEM**:<br>1. Every interface needs to use pam <br>or similar authentication<br>2. Network control on a system level needs <br>   to adhere to security best practices<br><br>**APP**:<br>1. Support the ability to disable SSID broadcast function<br>2. Support client white-list function<br>3. Support alarm on known vulnerable encryption (e.g., WEP)<br>4. Record client connection events<br>5. Support ACL integration<br>6. Application should  not use vulnerable protocols underneath<br><br> |
| CR-2.3         | Use control for portable and mobile devices                                      | FALSE            | FALSE            | FALSE                    | N.A.                             | There is no component level requirement                                                                                                                                                                                                                                                                                                                        |
| SAR-2.4        | Mobile code                                                                      | FALSE            | FALSE            | FALSE                    | N.A.                             | This requirement only applies to Software Applications                                                                                                                                                                                                                                                                                                         |
| SAR-2.4 RE(1)  | Mobile code - authenticity check                                                 | FALSE            | FALSE            | FALSE                    | N.A.                             | This requirement only applies to Software Applications                                                                                                                                                                                                                                                                                                         |
| EDR-2.4        | Mobile code                                                                      | FALSE            | TRUE             | FALSE                    | N.A.                             | This requirement is not supported by CIP.<br><br>Embedded devices only need to support this requirement if they utilize mobile code technologies such as Java, USB ports (autorun)<br>                                                                                                                                                                         |
| EDR-2.4 RE(1)  | Mobile code - authenticity check                                                 | FALSE            | TRUE             | FALSE                    | N.A.                             | Same as EDR-2.4                                                                                                                                                                                                                                                                                                                                                |
| HDR-2.4        | Mobile code                                                                      | FALSE            | TRUE             | FALSE                    | N.A.                             | It's for host devices                                                                                                                                                                                                                                                                                                                                          |
| HDR-2.4 RE(1)  | Mobile code - authenticity check                                                 | FALSE            | TRUE             | FALSE                    | N.A.                             | It's for host devices                                                                                                                                                                                                                                                                                                                                          |
| NDR-2.4        | Mobile code                                                                      | FALSE            | TRUE             | FALSE                    | N.A.                             | It's not applicable to CIP same as EDR-2.4                                                                                                                                                                                                                                                                                                                     |
| NDR-2.4 RE(1)  | Mobile code - authenticity check                                                 | FALSE            | TRUE             | FALSE                    | N.A.                             | It's not applicable to CIP same as EDR-2.4                                                                                                                                                                                                                                                                                                                     |
| CR-2.5         | Session lock                                                                     | TRUE             | TRUE             | FALSE                    | Completed<br>Added package openssh | CIP added openssh package to meet this requirement.<br><br>However, it's application developer's responsibility to configure timeout period for the session as well as terminating the session after timeout.<br><br>This can be implemented in many ways hence it's left to CIP users.                                                                        |
| CR-2.6         | Remote session termination                                                       | TRUE             | TRUE             | FALSE                    | Completed<br>Added package openssh | Same as CR-2.5                                                                                                                                                                                                                                                                                                                                                 |
| CR-2.7         | Concurrent session control                                                       | TRUE             | TRUE             | FALSE                    | Completed <br>Added pam and openssh package | Same as CR-2.5                                                                                                                                                                                                                                                                                                                                                 |
| CR-2.8         | Auditable events                                                                 | TRUE             | TRUE             | FALSE                    | Completed<br>Added package auditd | This requirement is supported by CIP.<br><br>However, application needs to configure applicable types of events for audit, all such events should be recorded which should be made available                                                                                                                                                                   |
| CR-2.9         | Audit storage capacity - allocation                                              | TRUE             | TRUE             | FALSE                    | Completed<br>Added package auditd and rsyslog | This requirement is supported by CIP.<br><br>However, application needs to configure log storage capacity, and when logs should be discarded after reaching certain configured storage limit.                                                                                                                                                                  |
| CR-2.9 RE(1)   | Warn when audit record storage capacity threshold reached                        | TRUE             | TRUE             | FALSE                    | Completed<br>Added package auditd and rsyslog | Same as CR-2.9                                                                                                                                                                                                                                                                                                                                                 |
| CR-2.10        | Response to audit processing failures                                            | TRUE             | TRUE             | FALSE                    | In-progress                      | CIP supports this requirement by adding packages auditd and rsyslog.<br><br>Applications need to harness capabilities of these packages and demonstrate to meet this requirement.                                                                                                                                                                              |
| CR-2.11        | Timestamp                                                                        | TRUE             | FALSE            | FALSE                    | Completed<br>Added package chrony | [Default Action](#Dafault_Action)                                                                                                                                                                                                                                                                                                                              |
| CR-2.11 RE(1)  | Time synchronization                                                             | TRUE             | FALSE            | FALSE                    | Completed<br>Added package chrony | CIP supports this requirement by chrony package.<br><br>However, application needs to configure logs in such a way that logs are generated with system time synchronized                                                                                                                                                                                       |
| CR-2.11 RE(2)  | Protection of time source integrity                                              | FALSE            | FALSE            | FALSE                    | N.A.                             | This is for SL-4                                                                                                                                                                                                                                                                                                                                               |
| CR-2.12        | Non-repudiation                                                                  | TRUE             | TRUE             | FALSE                    | Completed<br>Added packages audit and rsyslog | [Default Action](#Dafault_Action)                                                                                                                                                                                                                                                                                                                              |
| CR-2.12 RE(1)  | Non-repudiation for all users                                                    | FALSE            | FALSE            | FALSE                    | N.A.                             | This is for SL-4                                                                                                                                                                                                                                                                                                                                               |
| EDR-2.13       | Use of physical diagnostic and test interfaces                                   | FALSE            | FALSE            | TRUE                     | N.A.                             | Requires HW support                                                                                                                                                                                                                                                                                                                                            |
| EDR-2.13 RE(1) | Active monitoring                                                                | TRUE             | TRUE             | TRUE                     | Completed<br>Added packages rsyslog, auditd | CIP supports this requirement by adding required packages.<br><br>In order to meet this requirement application needs to do logging when diagnostic and test interfaces are accessed. All such interfaces should be considered as part of application or system threat model. If there are some interfaces which are used only during design and development , such interfaces should be removed before devices are shipped out. |
| HDR-2.13       | Use of physical diagnostic and test interfaces                                   | FALSE            | FALSE            | TRUE                     | N.A.                             | This requirement is for host devices                                                                                                                                                                                                                                                                                                                           |
| HDR-2.13 RE(1) | Active monitoring                                                                | TRUE             | FALSE            | TRUE                     | N.A.                             | Same as HDR-2.13                                                                                                                                                                                                                                                                                                                                               |



### 5.3 FR-3 System Integrity <a name="FR3"></a>

| Req ID         | Requirement name                                            | Supported by CIP | Need HW solution | Need application support | Status if supported by CIP                | CIP recommendation                                                                                                                                                                                                                                                     |
|----------------|-------------------------------------------------------------|------------------|------------------|--------------------------|-------------------------------------------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| CR-3.1         | Communication integrity                                     | TRUE             | TRUE             | FALSE                    | Completed<br>Added openssl package        | [Default Action](#Dafault_Action)<br><br>The platform provides capabilities for secure communication, application needs to use them                                                                                                                                    |
| CR 3.1 RE(1)   | Communication authentication                                | TRUE             | TRUE             | FALSE                    | Completed<br>Added openssl package        | Same as CR-3.1                                                                                                                                                                                                                                                         |
| SAR-3.2        | Protection from malicious code                              | FALSE            | FALSE            | FALSE                    | N.A.                                      | This requirement is only for Software application                                                                                                                                                                                                                      |
| EDR-3.2        | Protection from malicious code                              | FALSE            | TRUE             | FALSE                    | N.A.                                      | CIP does not support this requirement.<br><br>Applications are recommended to use signing and whitelisting to authenticate applications binaries                                                                                                                       |
| HDR-3.2        | Protection from malicious code                              | FALSE            | FALSE            | FALSE                    | N.A.                                      | This requirement applies to host devices                                                                                                                                                                                                                               |
| HDR-3.2 RE(1)  | Report version of code protection                           | FALSE            | FALSE            | FALSE                    | N.A.                                      | This requirement applies to host devices                                                                                                                                                                                                                               |
| NDR-3.2        | Protection from malicious code                              | FALSE            | TRUE             | FALSE                    | N.A.                                      | CIP does not support this requirement.<br><br>Application developers should use signing and whitelisting for meeting this requirement.                                                                                                                                 |
| CR-3.3         | Security functionality verification                         | FALSE            | TRUE             | FALSE                    | N.A.                                      | CIP does not support this requirement.<br><br>CIP users should verify the security functionality supported by the product according to this requirement                                                                                                                |
| CR-3.3 RE(1)   | Security functionality verification during normal operation | FALSE            | FALSE            | FALSE                    | N.A.                                      | This is for SL-4                                                                                                                                                                                                                                                       |
| CR-3.4         | Software and information integrity                          | TRUE             | TRUE             | FALSE                    | Completed<br>Added packages openssl, aide, aide-common | CIP supports this requirement.<br><br>However, application developer need to verify the integrity of software and configuration                                                                                                                                        |
| CR-3.4 RE(1)   | Authenticity of software and information                    | TRUE             | TRUE             | FALSE                    | Same as CR-3.4                            | Same as CR-3.4                                                                                                                                                                                                                                                         |
| CR 3.4 RE(2)   | Automated notification of integrity violations              | TRUE             | TRUE             | FALSE                    | Completed<br>Added rsyslog package        | Same as CR-3.4<br><br>Any mismatch in integrity data such as hash or checksum should be notified to other layers as well as logged for audit purpose. Once checksum or digital verification is failed, depending upon which layer it failed, the system needs to determine how to handle it, |
| CR-3.5         | Input validation                                            | TRUE             | TRUE             | FALSE                    | N.A.                                      | CIP users to make sure all the interfaces do input validation such as input for industrial process control, input via external interfaces                                                                                                                              |
| CR-3.6         | Deterministic output                                        | FALSE            | TRUE             | FALSE                    | N.A.                                      | CIP does not support this requirement.<br><br>CIP user should make sure it is met by application. Meeting this requirement is full responsibility of CIP user                                                                                                          |
| CR-3.7         | Error handling                                              | TRUE             | TRUE             | FALSE                    | Added rsyslog                             | CIP ensures no confidential information is exposed in logs which can be exploited by adversaries.<br><br>CIP users should ensure any sensitive information is not printed in the logs.                                                                                 |
| CR-3.8         | Session integrity                                           | TRUE             | TRUE             | FALSE                    | Completed<br>Added package openssl        | CIP platform provides low level package for session integrity. Application developers should use platform capabilities to protect application sessions.                                                                                                                |
| CR-3.9         | Protection of audit information                             | TRUE             | FALSE            | FALSE                    | Completed<br>Added package acl            | [Default Action](#Dafault_Action)                                                                                                                                                                                                                                      |
| CR-3.9 RE(1)   | Audit records on write-once media                           | FALSE            | FALSE            | FALSE                    | N.A.                                      | For SL-4                                                                                                                                                                                                                                                               |
| EDR-3.10       | Support for updates                                         | TRUE             | TRUE             | FALSE                    | in-progress                               | CIP provides reference implementation for software updates. However, CIP does not provide any software update for CIP users or devices.<br><br>CIP users can use CIP software update as reference implementation and develop software updates based on their requirements. |
| EDR-3.10 RE(1) | Update authenticity and integrity                           | TRUE             | TRUE             | FALSE                    | in-progress                               | Same as EDR-3.10                                                                                                                                                                                                                                                       |
| HDR-3.10       | Support for updates                                         | FALSE            | TRUE             | FALSE                    | N.A.                                      | This is for host devices not supported by CIP                                                                                                                                                                                                                          |
| HDR-3.10 RE(1) | Update authenticity and integrity                           | FALSE            | TRUE             | FALSE                    | N.A.                                      | This is for host devices not supported by CIP                                                                                                                                                                                                                          |
| NDR-3.10       | Support for updates                                         | TRUE             | TRUE             | FALSE                    | in-progress                               | Same as EDR-3.10                                                                                                                                                                                                                                                       |
| NDR-3.10 RE(1) | Update authenticity and integrity                           | TRUE             | TRUE             | FALSE                    | in-progress                               | Same as EDR-3.10                                                                                                                                                                                                                                                       |
| EDR-3.11       | Physical tamper resistance and detection                    | FALSE            | FALSE            | TRUE                     | N.A.                                      | Requires HW support                                                                                                                                                                                                                                                    |
| EDR-3.11 RE(1) | Notification of a tampering attempt                         | FALSE            | TRUE             | TRUE                     | N.A.                                      | CIP does not support this requirement.<br><br>CIP users should support this requirement.                                                                                                                                                                               |
| HDR-3.11       | Physical tamper resistance and detection                    | FALSE            | FALSE            | TRUE                     | N.A.                                      | This is for host devices                                                                                                                                                                                                                                               |
| HDR-3.11 RE(1) | Notification of a tampering attempt                         | FALSE            | FALSE            | TRUE                     | N.A.                                      | This is for host devices                                                                                                                                                                                                                                               |
| NDR-3.11       | Physical tamper resistance and detection                    | FALSE            | FALSE            | TRUE                     | N.A.                                      | Requires HW support                                                                                                                                                                                                                                                    |
| NDR-3.11 RE(1) | Notification of a tampering attempt                         | FALSE            | FALSE            | TRUE                     | N.A                                       | CIP does not support this requirement <br><br>This requirement should be supported by CIP users                                                                                                                                                                        |
| EDR-3.12       | Provisioning product supplier roots of trust - protection   | FALSE            | FALSE            | TRUE                     | N.A.                                      | CIP does not support this requirement.<br><br>This will be supported by CIP users                                                                                                                                                                                      |
| HDR-3.12       | Provisioning product supplier roots of trust - protection   | FALSE            | FALSE            | TRUE                     | N.A.                                      | It's for host devices                                                                                                                                                                                                                                                  |
| NDR-3.12       | Provisioning product supplier roots of trust - protection   | FALSE            | FALSE            | TRUE                     | N.A.                                      | Same as EDR-3.12                                                                                                                                                                                                                                                       |
| EDR-3.13       | Provisioning asset owner roots of trust - protection        | FALSE            | TRUE             | TRUE                     | N.A.                                      | CIP platform does not support this requirement.<br><br>CIP users should support this requirement by using CIP capability.                                                                                                                                              |
| HDR-3.13       | Provisioning asset owner roots of trust - protection        | FALSE            | FALSE            | TRUE                     | N.A.                                      | This is only applicable to host devices                                                                                                                                                                                                                                |
| NDR-3.13       | Provisioning asset owner roots of trust - protection        | FALSE            | TRUE             | TRUE                     | N.A.                                      | Same as EDR-3.13                                                                                                                                                                                                                                                       |
| EDR-3.14       | Integrity of the boot process                               | FALSE            | TRUE             | TRUE                     | in-progress                               | CIP provides reference implementation of secure boot implementation.<br><br>CIP users should meet it completely                                                                                                                                                        |
| EDR-3.14 RE(1) | Authenticity of the boot process                            | FALSE            | TRUE             | TRUE                     | in-progress                               | CIP provides reference implementation of secure boot implementation.<br><br>CIP users should meet it completely                                                                                                                                                        |
| HDR-3.14       | Integrity of the boot process                               | FALSE            | FALSE            | TRUE                     | N.A.                                      | It's for host devices                                                                                                                                                                                                                                                  |
| HDR-3.14 RE(1) | Authenticity of the boot process                            | FALSE            | FALSE            | TRUE                     | N.A.                                      | It's for host devices                                                                                                                                                                                                                                                  |
| NDR-3.14       | Integrity of the boot process                               | FALSE            | FALSE            | TRUE                     | in-progress                               | CIP provides reference implementation of secure boot implementation.<br><br>CIP users should meet it completely                                                                                                                                                        |
| NDR-3.14 RE(1) | Authenticity of the boot process                            | FALSE            | FALSE            | TRUE                     | in-progress                               | CIP provides reference implementation of secure boot implementation.<br><br>CIP users should meet it completely                                                                                                                                                        |


### 5.4 FR-4 Data Confidentiality <a name="FR4"></a>

| Req ID       | Requirement name                      | Supported by CIP | Need HW solution | Need application support | Status if supported by CIP                | CIP recommendation                                                                                                                                                    |
|--------------|---------------------------------------|------------------|------------------|--------------------------|-------------------------------------------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| CR-4.1       | Information confidentiality - at rest | TRUE             | TRUE             | FALSE                    | In-progress<br>Investigation to add packages in progress | CIP platform complies to this requirement<br><br>CIP users need to utilize the capabilities provided by CIP and encrypt data at rest                                  |
| CR-4.2       | Information persistence               | FALSE            | TRUE             | FALSE                    | N.A.                                      | CIP platform does not support this requirement<br><br>However CIP users can use CIP security packages to meet this requirement                                        |
| CR-4.2 RE(1) | Erase of shared memory resources      | TRUE             | TRUE             | FALSE                    | Completed<br>Added package ipcrm          | CIP meets this requirement by adding the packages.<br><br>CIP users should use CIP capabilities and make sure volatile memory contents are deleted as well as any data buffer allocated by application is reset before deleting |
| CR-4.2 RE(2) | Erase verification                    | TRUE             | TRUE             | FALSE                    | Completed<br>Added package ipcrm          | CIP users should support to confirm and acknowledge the erased contents are not accessible.                                                                           |
| CR-4.3       | Use of cryptography                   | TRUE             | FALSE            | FALSE                    | Completed <br>added openssl package       | CIP developers are investigating as per this requirement whether openssl meets the criteria.<br><br>In case if CIP users want to use another library instead of openssl, they should confirm the compliance as per this requirement |


### 5.5 FR-5 Restricted Data Flow <a name="FR5"></a>

| Req ID        | Requirement name                                             | Supported by CIP | Need HW solution | Need application support | Status if supported by CIP | CIP recommendation                                                                                                                                       |
|---------------|--------------------------------------------------------------|------------------|------------------|--------------------------|----------------------------|----------------------------------------------------------------------------------------------------------------------------------------------------------|
| CR-5.1        | Network segmentation                                         | FALSE            | TRUE             | FALSE                    | N.A.                       | CIP does not support this requirement.<br><br>CIP users should meet this requirement by using common networking protocols that are supported by switches and routers to implement network segmentation |
| NDR-5.2       | Zone boundary protection                                     | FALSE            | TRUE             | FALSE                    | N.A.                       | This is a product specific requirement, it should be met by CIP users by using CIP provided packages.                                                    |
| NDR-5.2 RE(1) | Deny all, permit by exception                                | FALSE            | TRUE             | FALSE                    | N.A.                       | Same as NDR-5.2                                                                                                                                          |
| NDR-5.2 RE(2) | Island mode                                                  | FALSE            | TRUE             | FALSE                    | N.A.                       | Same as NDR-5.2                                                                                                                                          |
| NDR-5.2 RE(3) | Fail close                                                   | TRUE             | FALSE            | TRUE                     | N.A.                       | Same as NDR-5.2                                                                                                                                          |
| NDR-5.3       | General purpose, person-to-person communication restrictions | FALSE            | TRUE             | FALSE                    | N.A.                       | This is a product specific requirement and has to be met by CIP users.<br><br>This can be done by blocking specific ports that are used by applications to communicate general purpose messages between person to person |
| CR-5.4        | Application partitioning                                     | FALSE            | FALSE            | FALSE                    | N.A.                       | No component level requirement                                                                                                                           |


### 5.6 FR-6 Timely Response to Events <a name="FR6"></a>

| Req ID       | Requirement name                  | Supported by CIP | Need HW solution | Need application support | Status if supported by CIP           | CIP recommendations                                                                                           |
|--------------|-----------------------------------|------------------|------------------|--------------------------|--------------------------------------|---------------------------------------------------------------------------------------------------------------|
| CR-6.1       | Audit log accessibility           | TRUE             | TRUE             | FALSE                    | Completed<br>Added auditd, auditspd-plugins | CIP supports this requirement by adding the required packages.<br><br>CIP users need to utilize the capabilities provided by CIP to limit the access of logs |
| CR-6.1 RE(1) | Programmatic access to audit logs | TRUE             | TRUE             | FALSE                    | Completed<br>Added auditd, auditspd-plugins | Same as CR-6.1                                                                                                |
| CR-6.2       | Continuous monitoring             | TRUE             | TRUE             | FALSE                    | Completed<br>Added syslog-ng and related packages | CIP supports this requirement and further capabilities should be added by CIP users to meet this requirement. |


### 5.7 FR-7 Resource Availability <a name="FR7"></a>


| Req ID       | Requirement name                                        | Supported by CIP | Need HW solution | Need application support | Status if supported by CIP    | CIP recommendation                                                                                                                                                             |
|--------------|---------------------------------------------------------|------------------|------------------|--------------------------|-------------------------------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| CR-7.1       | Denial of service protection                            | TRUE             | TRUE             | FALSE                    | Completed<br>Added package nftables | CIP supports this requirement.<br><br>CIP users should do CRT (communication Robustness Testing) to meet this requirement.                                                     |
| CR-7.1 RE(1) | Manage communication load from component                | TRUE             | TRUE             | FALSE                    | Completed<br>Added package nftables | CIP supports this requirement.<br><br>CIP users should use CIP package and make sure in case of DoS attack essential function of the system is not affected and system runs in degraded mode with essential services |
| CR-7.2       | Resource management                                     | FALSE            | TRUE             | FALSE                    | N.A.                          | CIP platform does not support this requirement<br><br>CIP users should make sure monitoring of system does not affect essential functions of the system                        |
| CR-7.3       | Control system backup                                   | TRUE             | FALSE            | FALSE                    | in-progress<br>Adding backup/restore package | CIP supports this requirement.<br><br>CIP users should use the package and configure based on this requirement                                                                 |
| CR-7.3 RE(1) | Backup integrity verification                           | TRUE             | FALSE            | FALSE                    | in-progress<br>Adding backup/restore package | Same as CR-7.3                                                                                                                                                                 |
| CR-7.4       | Control system recovery and reconstitution              | TRUE             | TRUE             | FALSE                    | in-progress<br>Adding backup/restore package | Same as CR-7.3                                                                                                                                                                 |
| CR-7.5       | Emergency power                                         | FALSE            | FALSE            | FALSE                    | N.A.                          | No component level requirement                                                                                                                                                 |
| CR-7.6       | Network and security configuration settings             | FALSE            | TRUE             | FALSE                    | N.A.                          | CIP does not support this requirement<br><br>CIP users should provide setting to configure network and security settings based on the product uses cases                       |
| CR-7.6 RE(1) | Machine-readable reporting of current security settings | FALSE            | TRUE             | FALSE                    | N.A.                          | Same as CR-7.6                                                                                                                                                                 |
| CR-7.7       | Least functionality                                     | FALSE            | TRUE             | FALSE                    | N.A.                          | CIP platform does not support this requirement.<br><br>CIP users should use CIP capabilities and support it.                                                                   |
| CR-7.8       | Control system component inventory                      | FALSE            | TRUE             | FALSE                    | N.A.                          | Same as CR-7.7                                                                                                                                                                 |


## 6. CIP Security packages <a name="cip_security_packages"></a>

All the security packages added in isar-cip-core can be found at CIP [Security images](https://gitlab.com/cip-project/cip-core/isar-cip-core/-/blob/master/recipes-core/images/cip-core-image-security.bb)

In addition section 5 of this document has reference to all packages along with the security requirements.

## 7. IEC Security Layer <a name="iec_security_layer"></a>

CIP developer extensively investigated IEC-62443-4-2 security requirements and available Debian packages to meet the IEC requirements.

These packages form IEC security layer in CIP. 

### 7.1 Running security tests <a name="running_security_tests"></a>

IEC security tests can be executed by following the steps specified at [CIP Security Tests gitlab ](https://gitlab.com/cip-project/cip-testing/cip-security-tests)

### 7.2 Adding security package <a name="adding_new_package"></a>

Adding security packages to isar-cip-core has two steps.

**Step-1**

Create a package proposal ([PDP process](https://gitlab.com/cip-project/cip-core/cip-pkglist/-/blob/master/doc/pdp.md))with the required details of the package which needs to be added and send it for CIP Core WG review and approval. Once approval is completed, the package can be added to the isar-cip-core gitlab repository

**Step-2**

Add package to isar-cip-core ([isar-cip-core git lab repo](https://gitlab.com/cip-project/cip-core/isar-cip-core/-/blob/master/recipes-core/images/cip-core-image-security.bb)) repositery and send the MR for review and approval.

### 7.3 Adding security test <a name="adding_security_test"></a>

TBD